//
// automatically generated by spin2cpp v1.04 on Wed May  8 08:09:37 2013
// spin2cpp --ccode --files TestNunchuck.spin 
//
// Changes: 05/08/2013 - dgately
// 
// This project is now a C implementation
// -Removed/comented-out reference and code to .spin floating point (Float32.spin & Float32A.spin)
// -Rewrote Radius, Pitch and Roll routines to use C floating point functions (in Nunchuk.c)
// -Used the proper name "Nunchuk" during modifications :-)
// -i2cObject.c is a direct spin2cpp translation of i2cObject.spin
//
// Original Spin code authors are noted near the top of .c files
//

/*
Wii Nunchuck Driver Demo Object v1.0
By Pat Daderko (DogP)

Based on a Wii nunchuck example project from John Abshier, which was based on code originally by João Geada

This demo object repeatedly polls the Wii Nunchuck and writes the data to the serial port (at 115200bps),
reusing the pins used for programming.

Note there is no yaw, as that can't be determined from the accelerometers.  This also limits the pitch
to 180 degrees and will cause incorrect roll readings when the pitch is between 180 deg and 360 deg.

Also note that the Nunchuck can't be constantly read, or bad data will be returned.

See other notes in the driver object.     

Diagram below is showing the pinout looking into the connector (which plugs into the Wii Remote)
 _______ 
| 1 2 3 |
|       |
| 6 5 4 |
|_-----_|

1 - SDA 
2 - 
3 - VCC
4 - SCL 
5 - 
6 - GND

This is an I2C peripheral, and requires a pullup resistor on the SDA line
If using a prop board with an I2C EEPROM, this can be connected directly to pin 28 (SCL) and pin 29 (SDA)
*/

//#include <propeller.h>
#include "TestWiiNunChukC.h"
#include "simpletools.h"

static TestNunchuck thisobj;
int32_t TestNunchuck_Init(void)
{
  Nunchuck_Init(0, 1);          // Must set Nunchuk sclk, sda pins here!!!
  return 0;
}

int32_t main(void)
{
  TestNunchuck_Init();

  while (1) {

    Nunchuck_Readnunchuck();

    printf("%cWii Nunchuk Test\n\n",16);
    printf("Joystick X: %d    Y: %d\n",Nunchuck_Joyx(),Nunchuck_Joyy());
    printf("Accelerometer X: %d    Y: %d    Z: %d\n",Nunchuck_Accelx(),Nunchuck_Accely(),Nunchuck_Accelz());
    printf("Pitch: %3.2f    Roll: %3.2f\n",Nunchuck_Pitch(),Nunchuck_Roll());
    printf("Button C: %d    Z: %d\n",Nunchuck_Buttonc(),Nunchuck_Buttonz());

    pause(150);               // refresh every quarter second
  }
  return 0;
}

/*
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
*/